﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace SkypeDialer.Configuration
{
    public class ContactInfoAttribute
    {
        public ContactInfoAttribute(string attributeName, bool callAvail, bool videoAvail, bool chatAvail, bool smsAvail, bool statusAvail)
        {
            AttributeName = attributeName;
            IsCallAvailable = callAvail;
            IsVideoCallAvailable = videoAvail;
            IsChatAvailable = chatAvail;
            IsSMSAvailable = smsAvail;
            IsStatusAvailable = statusAvail;
        }

        public string AttributeName { get; set; }

        /// <summary>
        /// Call available?
        /// </summary>
        public bool IsCallAvailable { get; set; }

        /// <summary>
        /// Video call available?
        /// </summary>
        public bool IsVideoCallAvailable { get; set; }

        /// <summary>
        /// Chat available?
        /// </summary>
        public bool IsChatAvailable { get; set; }

        /// <summary>
        /// Is SMS Available
        /// </summary>
        public bool IsSMSAvailable { get; set; }

        /// <summary>
        /// Is status available for this ID
        /// </summary>
        public bool IsStatusAvailable { get; set; }

    }

    public class ContactInfoEntity
    {
        public string EntityName { get; set; }

        public List<ContactInfoAttribute> ContactInfoAttributes { get; set; }
    }

    public interface ICrmDataAdapterConfigurationProvider
    {
        Dictionary<string, ContactInfoEntity> ContactInfoEntities
        {
            get;
        }
    }
}